## duma 2.5.14

=== Makefile ===
#
# add "-DDUMA_NO_GLOBAL_MALLOC_FREE" (without quotes)
#   for not defining malloc/free in global namespace
#
# add "-DDUMA_EXPLICIT_INIT" (without quotes)
#    to do all the "risky" stuff getenv(), sem_init(), write() .. explicitly
#      from main().
#    you have to call duma_init() explicitly from main() this option also
#    avoids leak error messages for allocations before duma_init() got called.
#    this helps for leaky standard environments.
#
# add "-DDUMA_NO_THREAD_SAFETY" (without quotes)
#    for not supporting multi-threading
#
# add "-DDUMA_SEMAPHORES" (without quotes)
#    for using pthread semaphores
#    elseway pthread mutexes get used
#
# add "-DDUMA_SO_NO_CPP_SUPPORT" or "-DDUMA_LIB_NO_CPP_SUPPORT" (without quotes)
#    for not directing new/delete to malloc/free
#
# add "-DDUMA_SO_NO_LEAKDETECTION" or "-DDUMA_LIB_NO_LEAKDETECTION" (without quotes)
#    if you don't want support for leak detection
#
# add "-DDUMA_SO_PREFER_ATEXIT" or "-DDUMA_LIB_PREFER_ATEXIT" (without quotes)
#    if you prefer atexit() over GNU Compiler's function attribute "destructor"
#
# add "-DDUMA_SO_PREFER_GETENV" or "-DDUMA_LIB_PREFER_GETENV" (without quotes)
#    if you prefer standard C library getenv() over global char **environ
#
# add "-DDUMA_OLD_NEW_MACRO" (without quotes)
#    if you want to use DUMA's old style NEW_ELEM() / NEW_ARRAY() macros.
#    when not defining this option, a standard conform new syntax can get used.
#    unfortunately you have to use DEL_ELEM/DEL_ARRAY further to utilize
#    filename and linenumber of deallocation calls
#
# add "-DDUMA_SO_NO_HANG_MSG" or "-DDUMA_LIB_NO_HANG_MSG" (without quotes)
#    set this if you want to suppress the extra messages around atexit().
#
# add "-DDUMA_NO_STRERROR" (without quotes)
#    set this if you want to suppress calls to strerror() to avoid recursion
#    on specific platforms.
#
########################################
#
#  preprocessor flags for building the shared library (DUMA_SO_LIBRARY):
#    - DUMA_SO_NO_CPP_SUPPORT
#    - DUMA_SO_NO_LEAKDETECTION
#    - DUMA_SO_PREFER_ATEXIT
#    - DUMA_SO_PREFER_GETENV
#    - DUMA_SO_NO_HANG_MSG
#
#  preprocessor flags for building the static library:
#    - DUMA_LIB_NO_CPP_SUPPORT
#    - DUMA_LIB_NO_LEAKDETECTION
#    - DUMA_LIB_PREFER_ATEXIT
#    - DUMA_LIB_PREFER_GETENV
#    - DUMA_LIB_NO_HANG_MSG
#    - DUMA_NO_GLOBAL_MALLOC_FREE
#    - DUMA_EXPLICIT_INIT
#    - DUMA_NO_THREAD_SAFETY
#    - DUMA_OLD_NEW_MACRO
#    - DUMA_OLD_DEL_MACRO
#    - DUMA_NO_STRERROR
#
########################################

# edit following line
DUMA_OPTIONS =

# no leak detection on any platform:
# use static library for finding leaks - with information memory was allocated
# i think leak-checking without further information is quite useless!
# additionaly too many platforms/environments are broken.
DUMA_OPTIONS += -DDUMA_SO_NO_LEAKDETECTION

# some test cases:
#DUMA_OPTIONS += -DDUMA_LIB_NO_LEAKDETECTION
#DUMA_OPTIONS += -DDUMA_NO_THREAD_SAFETY
#DUMA_OPTIONS += -DDUMA_NO_CPP_SUPPORT

PIC= -fPIC -DPIC
DUMA_SO_OPTIONS = $(PIC) -DDUMA_SO_LIBRARY

# for FreeBSD 5.4
# DUMA_OPTIONS += -DPAGE_PROTECTION_VIOLATED_SIGNAL=SIGBUS
#
# for FreeBSD 5.4 if DUMA_EXPLICIT_INIT is not set
# DUMA_OPTIONS += -DDUMA_NO_LEAKDETECTION
#
# for cygwin environment on Windows
# DUMA_OPTIONS += -DDUMA_EXPLICIT_INIT
# also define 'WIN32'

# some defaults:
CC=gcc
CXX=g++
AR=ar
RANLIB=ranlib
INSTALL=install
RM=rm
RMFORCE=rm -f
ECHO=echo
ECHOLF=echo

# dynamic dependencies
DUMA_DYN_DEPS = $(DUMASO) tstheap_so$(EXEPOSTFIX) dumatestpp_so$(EXEPOSTFIX)

# some OS specific:

ifeq ($(OS), Windows_NT)
  ifeq ($(OSTYPE), msys)
    # call mingw32-make OSTYPE=msys
    # from Windows command prompt
    # having added the PATH for MINGW/bin
    # using explicit initialization to avoid leak report
    # from __w32_sharedptr_initialize() function
    DUMA_OPTIONS += -DDUMA_EXPLICIT_INIT
    RM=del
    RMFORCE=del /F 2>nul
    ECHO=echo
    ECHOLF=echo .
    CURPATH=
    DUMA_DYN_DEPS=
    DUMASO=
    CFLAGS= -g -O0
    CPPFLAGS= -g -O0
    LIBS=
    EXEPOSTFIX=.exe
  else
    ifeq ($(OSTYPE), cygwin)
      # call make OSTYPE=cygwin
      DUMA_OPTIONS += -DDUMA_EXPLICIT_INIT
      CURPATH=./
      DUMA_DYN_DEPS=
      DUMASO=
      CFLAGS= -g -O0 -DWIN32
      CPPFLAGS= -g -O0 -DWIN32
      LIBS=
      EXEPOSTFIX=.exe
    else
      DUMA_OPTIONS += -DDUMA_EXPLICIT_INIT
      CURPATH=./
      DUMA_DYN_DEPS=
      DUMASO=
      CFLAGS= -g -O0 -DWIN32
      CPPFLAGS= -g -O0 -DWIN32
      LIBS=
      EXEPOSTFIX=.exe
    endif
  endif
else
  ifeq ($(OS), osx)
    # tested on darwin 8.0, which is the base for mac-osx
    # call: make OS=osx
    DUMA_OPTIONS += -DPAGE_PROTECTION_VIOLATED_SIGNAL=SIGBUS
    DUMA_OPTIONS += -DDUMA_SO_PREFER_GETENV
#    DUMA_OPTIONS += -DDUMA_LIB_NO_LEAKDETECTION
    CURPATH=./
#    DUMA_DYN_DEPS=
    DUMASO=libduma.dylib
    DUMASO_LINK1=libduma.dylib
    CFLAGS= -g -O0
    CPPFLAGS= -g -O0
    LIBS=-lpthread
    EXEPOSTFIX=
  else
    ifeq ($(OS), freebsd)
      DUMA_OPTIONS += -DDUMA_NO_THREAD_SAFETY
      DUMA_OPTIONS += -DDUMA_EXPLICIT_INIT
      CURPATH=./
      DUMA_DYN_DEPS=
      DUMASO=
      DUMASO_LINK1=
      CFLAGS= -g -O0
      CPPFLAGS= -g -O0
      LIBS=-lpthread
      EXEPOSTFIX=
    else
      ifeq ($(OS), netbsd)
          CURPATH=./
          DUMASO=libduma.so.0.0.0
          DUMASO_LINK1=libduma.so.0
          DUMASO_LINK2=libduma.so
          CFLAGS= -g -O0
          CPPFLAGS= -g -O0
          LIBS=-lpthread
          EXEPOSTFIX=
      else
        ifeq ($(OS), solaris)
          DUMA_OPTIONS += -DDUMA_NO_STRERROR
          CURPATH=./
          DUMA_DYN_DEPS=
          DUMASO=libduma.so.0.0.0
          DUMASO_LINK1=libduma.so.0
          DUMASO_LINK2=libduma.so
          CFLAGS= -g -O0
          CPPFLAGS= -g -O0
          LDFLAGS+=-lgcc_s
          LDOPTIONS+=-lgcc_s
          LIBS=-Wl,-R/opt/sfw/lib -lpthread
          EXEPOSTFIX=
        else
          # default is Linux or other full Unix
          CURPATH=./
          DUMASO=libduma.so.0.0.0
          DUMASO_LINK1=libduma.so.0
          DUMASO_LINK2=libduma.so
          CFLAGS= -g -O0 -Wall
          CPPFLAGS= -g -O0 -Wall
          LIBS=-lpthread
          EXEPOSTFIX=
        endif
      endif
    endif
  endif
endif


############################################################

prefix=/usr
BIN_INSTALL_DIR=$(prefix)/bin
LIB_INSTALL_DIR=$(prefix)/lib
MAN_INSTALL_DIR=$(prefix)/share/man/man3
INC_INSTALL_DIR=$(prefix)/include
DOC_INSTALL_DIR=$(prefix)/share/doc/duma

PACKAGE_SOURCE= README.txt CHANGELOG COPYING-GPL COPYING-LGPL duma.3 Makefile gdbinit.rc \
	duma.h dumapp.h duma_sem.h paging.h print.h duma_hlp.h noduma.h \
	duma.c dumapp.cpp sem_inc.c print.c \
	dumatest.c tstheap.c thread-test.c testmt.c dumatestpp.cpp testoperators.cpp \
	createconf.c

OBJECTS = dumapp.o duma.o sem_inc.o print.o

SO_OBJECTS = dumapp_so.o duma_so.o sem_inc_so.o print_so.o

all:	libduma.a tstheap$(EXEPOSTFIX) dumatest$(EXEPOSTFIX) thread-test$(EXEPOSTFIX) testmt$(EXEPOSTFIX) dumatestpp$(EXEPOSTFIX) testoperators$(EXEPOSTFIX) $(DUMA_DYN_DEPS)

test:
	@ $(ECHOLF)
	@ $(ECHO) "Testing DUMA (static library):"
	$(CURPATH)dumatest$(EXEPOSTFIX)
	$(CURPATH)tstheap$(EXEPOSTFIX) 3072
	$(CURPATH)testoperators$(EXEPOSTFIX)
	@ $(ECHOLF)
	@ $(ECHO) "DUMA static confidence test PASSED."
ifdef DUMASO
	@ $(ECHOLF)
	@ $(ECHO) "Testing DUMA (dynamic library)."
ifeq ($(OS), solaris)
	(LD_PRELOAD=./$(DUMASO) DYLD_INSERT_LIBRARIES=./$(DUMASO) DYLD_FORCE_FLAT_NAMESPACE=1 exec $(CURPATH)tstheap_so 3072)
else
	(export LD_PRELOAD=./$(DUMASO); export DYLD_INSERT_LIBRARIES=./$(DUMASO); export DYLD_FORCE_FLAT_NAMESPACE=1; exec $(CURPATH)tstheap_so 3072)
endif
	@ $(ECHOLF)
	@ $(ECHO) "DUMA dynamic confidence test PASSED."
	@ $(ECHOLF)
endif

install: libduma.a duma.3 $(DUMASO)
	- mkdir -p $(DESTDIR)$(DOC_INSTALL_DIR)
	$(INSTALL) -m 644 README.txt $(DESTDIR)$(DOC_INSTALL_DIR)
	- mkdir -p $(DESTDIR)$(INC_INSTALL_DIR)
	$(INSTALL) -m 644 noduma.h duma.h dumapp.h duma_sem.h duma_config.h $(DESTDIR)$(INC_INSTALL_DIR)
	- mkdir -p $(DESTDIR)$(BIN_INSTALL_DIR)
	$(INSTALL) -m 755 duma.sh $(DESTDIR)$(BIN_INSTALL_DIR)/duma
	- mkdir -p $(DESTDIR)$(LIB_INSTALL_DIR)
	$(INSTALL) -m 644 libduma.a $(DESTDIR)$(LIB_INSTALL_DIR)
ifdef DUMASO
	$(INSTALL) -m 755 $(DUMASO) $(DESTDIR)$(LIB_INSTALL_DIR)
endif
ifdef DUMASO_LINK1
	- $(RMFORCE) $(DESTDIR)$(LIB_INSTALL_DIR)/$(DUMASO_LINK1)
	ln -s $(DUMASO) $(DESTDIR)$(LIB_INSTALL_DIR)/$(DUMASO_LINK1)
endif
ifdef DUMASO_LINK2
	- $(RMFORCE) $(DESTDIR)$(LIB_INSTALL_DIR)/$(DUMASO_LINK2)
	ln -s $(DUMASO) $(DESTDIR)$(LIB_INSTALL_DIR)/$(DUMASO_LINK2)
endif
	- mkdir -p $(DESTDIR)$(MAN_INSTALL_DIR)
	$(INSTALL) -m 644 duma.3 $(DESTDIR)$(MAN_INSTALL_DIR)/duma.3

clean:
	- $(RMFORCE) $(OBJECTS) $(SO_OBJECTS) tstheap.o dumatest.o thread-test.o testmt.o dumatestpp.o \
		tstheap_so.o dumatestpp_so.o testoperators.o \
		tstheap$(EXEPOSTFIX) tstheap_so$(EXEPOSTFIX) dumatest$(EXEPOSTFIX) dumatestpp$(EXEPOSTFIX) dumatestpp_so$(EXEPOSTFIX) testoperators$(EXEPOSTFIX) \
		thread-test$(EXEPOSTFIX) testmt$(EXEPOSTFIX) \
		libduma.a $(DUMASO) libduma.cat DUMA.shar

distclean clobber: clean
	- $(RMFORCE) duma_config.h createconf.o createconf$(EXEPOSTFIX)

roff:
	nroff -man < duma.3 > duma.cat


DUMA.shar: $(PACKAGE_SOURCE)
	shar $(PACKAGE_SOURCE) > DUMA.shar

shar: DUMA.shar

libduma.a: duma_config.h $(OBJECTS)
	- $(RMFORCE) libduma.a
	$(AR) crv libduma.a $(OBJECTS)
	$(RANLIB) libduma.a

duma_config.h: 
	$(MAKE) reconfig

reconfig: createconf$(EXEPOSTFIX) createconf.o createconf.c
	- $(CURPATH)createconf$(EXEPOSTFIX)

dos2unix:
	@ dos2unix --d2u $(PACKAGE_SOURCE)

createconf$(EXEPOSTFIX): createconf.o
	- $(RMFORCE) createconf$(EXEPOSTFIX)
	$(CC) $(CFLAGS) $(DUMA_OPTIONS) createconf.o -o createconf$(EXEPOSTFIX)

tstheap$(EXEPOSTFIX): libduma.a tstheap.o
	- $(RMFORCE) tstheap$(EXEPOSTFIX)
	$(CC) $(CFLAGS) tstheap.o libduma.a -o tstheap$(EXEPOSTFIX) $(LIBS)

dumatest$(EXEPOSTFIX): libduma.a dumatest.o
	- $(RMFORCE) dumatest$(EXEPOSTFIX)
	$(CC) $(CFLAGS) dumatest.o libduma.a -o dumatest$(EXEPOSTFIX) $(LIBS)

dumatestpp$(EXEPOSTFIX): libduma.a dumatestpp.o duma_sem.h dumapp.h
	- $(RMFORCE) dumatestpp$(EXEPOSTFIX)
	$(CXX) $(CPPFLAGS) dumatestpp.o libduma.a -o dumatestpp$(EXEPOSTFIX) $(LIBS)

thread-test$(EXEPOSTFIX): libduma.a thread-test.o
	- $(RMFORCE) thread-test$(EXEPOSTFIX)
	$(CC) $(CFLAGS) thread-test.o libduma.a -o thread-test$(EXEPOSTFIX) $(LIBS)

testmt$(EXEPOSTFIX): libduma.a testmt.o
	- $(RMFORCE) testmt$(EXEPOSTFIX)
	$(CC) $(CFLAGS) testmt.o libduma.a -o testmt$(EXEPOSTFIX) $(LIBS)

testoperators$(EXEPOSTFIX): libduma.a testoperators.o duma_sem.h dumapp.h
	- $(RMFORCE) testoperators$(EXEPOSTFIX)
	$(CXX) $(CPPFLAGS) testoperators.o libduma.a -o testoperators$(EXEPOSTFIX) $(LIBS)

tstheap_so$(EXEPOSTFIX): tstheap_so.o
	- $(RMFORCE) tstheap_so$(EXEPOSTFIX)
	$(CC) $(CFLAGS) tstheap_so.o -o tstheap_so$(EXEPOSTFIX) $(LIBS)

dumatestpp_so$(EXEPOSTFIX): dumatestpp_so.o
	- $(RMFORCE) dumatestpp_so$(EXEPOSTFIX)
	$(CXX) $(CPPFLAGS) dumatestpp_so.o -o dumatestpp_so$(EXEPOSTFIX) $(LIBS)


$(OBJECTS) tstheap.o dumatest.o thread-test.o testmt.o dumatestpp.o: duma.h

ifeq ($(OS), Windows_NT)
  # do nothing
else
  ifeq ($(OS), osx)

$(DUMASO): duma_config.h $(SO_OBJECTS)
	$(CXX) -g -dynamiclib -Wl -o $(DUMASO) $(SO_OBJECTS) -lpthread -lc
	$(CXX) -g -dynamiclib -o $(DUMASO) $(SO_OBJECTS) -lpthread -lc

  else

$(DUMASO): duma_config.h $(SO_OBJECTS)
	$(CXX) -g -shared -Wl,-soname,$(DUMASO) -o $(DUMASO) $(SO_OBJECTS) -lpthread -lc
#	$(CXX) -g -shared -o $(DUMASO) $(SO_OBJECTS) -lpthread -lc

  endif

endif


#
# define rules how to build objects for createconf
#
createconf.o:
	$(CC) $(CFLAGS) $(DUMA_OPTIONS) -c createconf.c -o $@


#
# define rules how to build objects for shared library
#

dumapp_so.o:	dumapp.cpp duma.h duma_sem.h dumapp.h
	$(CXX) $(CPPFLAGS) $(DUMA_SO_OPTIONS) -c dumapp.cpp -o $@

duma_so.o:	duma.c duma.h duma_config.h
	$(CC) $(CFLAGS) $(DUMA_SO_OPTIONS) -c duma.c -o $@

## duma 2.5.15

=== comparisons/ex13/Makefile ===

DUMADIR=../..
CFLAGS=-g -O0 -I$(DUMADIR) -include stdlib.h -include duma.h
LFLAGS=$(DUMADIR)/libduma.a
ifeq ($(OS), Windows_NT)
  LIBS=
else
  LIBS=-lpthread
endif

CC=gcc
CXX=g++

BIN=wrong6
OBJ=$(BIN).o

all: $(BIN)
	./$(BIN)

clean:
	- rm -f $(OBJ) $(BIN)

$(BIN): $(OBJ)
	$(CC) $(OBJ) $(LFLAGS) $(LIBS) -o $(BIN)

.c.o:
	$(CC) $(CFLAGS) -c $< -o $@

=== comparisons/ex14/Makefile ===

DUMADIR=../..
CFLAGS=-g -O0 -I$(DUMADIR) -include stdlib.h -include duma.h
LFLAGS=$(DUMADIR)/libduma.a
ifeq ($(OS), Windows_NT)
  LIBS=
else
  LIBS=-lpthread
endif

CC=gcc
CXX=g++

BIN=wrong7
OBJ=$(BIN).o

all: $(BIN)
	./$(BIN)

clean:
	- rm -f $(OBJ) $(BIN)

$(BIN): $(OBJ)
	$(CC) $(OBJ) $(LFLAGS) $(LIBS) -o $(BIN)

.c.o:
	$(CC) $(CFLAGS) -c $< -o $@

=== comparisons/ex15/Makefile ===

DUMADIR=../..
CFLAGS=-g -O0 -I$(DUMADIR) -include stdlib.h -include duma.h
LFLAGS=$(DUMADIR)/libduma.a
ifeq ($(OS), Windows_NT)
  LIBS=
else
  LIBS=-lpthread
endif

CC=gcc
CXX=g++

BIN=leak1
OBJ=$(BIN).o

all: $(BIN)
	./$(BIN)

clean:
	- rm -f $(OBJ) $(BIN)

$(BIN): $(OBJ)
	$(CC) $(OBJ) $(LFLAGS) $(LIBS) -o $(BIN)

.c.o:
	$(CC) $(CFLAGS) -c $< -o $@

=== comparisons/ex21/Makefile ===

DUMADIR=../..
CPPFLAGS=-g -O0 -I$(DUMADIR) -include stdlib.h -include new -include dumapp.h
LFLAGS=$(DUMADIR)/libduma.a
ifeq ($(OS), Windows_NT)
  LIBS=
else
  LIBS=-lpthread
endif

CC=gcc
CXX=g++

BIN=wrong1
OBJ=$(BIN).o

all: $(BIN)
	./$(BIN)

clean:
	- rm -f $(OBJ) $(BIN)

$(BIN): $(OBJ)
	$(CXX) $(OBJ) $(LFLAGS) $(LIBS) -o $(BIN)

.cc.o:
	$(CXX) $(CPPFLAGS) -c $< -o $@

=== comparisons/ex22/Makefile ===

DUMADIR=../..
CPPFLAGS=-g -O0 -I$(DUMADIR) -include stdlib.h -include new -include dumapp.h
LFLAGS=$(DUMADIR)/libduma.a
ifeq ($(OS), Windows_NT)
  LIBS=
else
  LIBS=-lpthread
endif

CC=gcc
CXX=g++

BIN=wrong2
OBJ=$(BIN).o

all: $(BIN)
	./$(BIN)

clean:
	- rm -f $(OBJ) $(BIN)

$(BIN): $(OBJ)
	$(CXX) $(OBJ) $(LFLAGS) $(LIBS) -o $(BIN)

.cc.o:
	$(CXX) $(CPPFLAGS) -c $< -o $@

=== comparisons/ex24/Makefile ===

DUMADIR=../..
CPPFLAGS=-g -O0 -I$(DUMADIR) -include stdlib.h -include new -include dumapp.h
LFLAGS=$(DUMADIR)/libduma.a
ifeq ($(OS), Windows_NT)
  LIBS=
else
  LIBS=-lpthread
endif

CC=gcc
CXX=g++

BIN=wrong4
OBJ=$(BIN).o

all: $(BIN)
	./$(BIN)

clean:
	- rm -f $(OBJ) $(BIN)

$(BIN): $(OBJ)
	$(CXX) $(OBJ) $(LFLAGS) $(LIBS) -o $(BIN)

.cc.o:
	$(CXX) $(CPPFLAGS) -c $< -o $@

=== comparisons/ex27/Makefile ===

DUMADIR=../..
CPPFLAGS=-g -O0 -I$(DUMADIR) -include stdlib.h -include new -include dumapp.h
LFLAGS=$(DUMADIR)/libduma.a
ifeq ($(OS), Windows_NT)
  LIBS=
else
  LIBS=-lpthread
endif

CC=gcc
CXX=g++

BIN=leak1
OBJ=$(BIN).o

all: $(BIN)
	./$(BIN)

clean:
	- rm -f $(OBJ) $(BIN)

$(BIN): $(OBJ)
	$(CXX) $(OBJ) $(LFLAGS) $(LIBS) -o $(BIN)

.cc.o:
	$(CXX) $(CPPFLAGS) -c $< -o $@

=== example_makes/ex1/Makefile ===

DUMADIR=../..
CPPFLAGS=-g -O0 -I$(DUMADIR)
LFLAGS=$(DUMADIR)/libduma.a
ifeq ($(OS), Windows_NT)
  LIBS=
else
  LIBS=-lpthread
endif

CC=gcc
CXX=g++

BIN=example1
OBJ=../../$(BIN).o

all: $(BIN)
	./$(BIN)

clean:
	- rm -f $(OBJ) $(BIN)

$(BIN): $(OBJ)
	$(CXX) $(OBJ) $(LFLAGS) $(LIBS) -o $(BIN)

=== example_makes/ex4/Makefile ===

DUMADIR=../..
CPPFLAGS=-g -O0 -I$(DUMADIR)
LFLAGS=$(DUMADIR)/libduma.a
ifeq ($(OS), Windows_NT)
  LIBS=
else
  LIBS=-lpthread
endif

CC=gcc
CXX=g++

BIN=example4
OBJ=../../$(BIN).o

all: $(BIN)
	./$(BIN)

clean:
	- rm -f $(OBJ) $(BIN)

$(BIN): $(OBJ)
	$(CXX) $(OBJ) $(LFLAGS) $(LIBS) -o $(BIN)

=== example_makes/ex5/Makefile ===

DUMADIR=../..
CPPFLAGS=-g -O0 -I$(DUMADIR)
LFLAGS=$(DUMADIR)/libduma.a
ifeq ($(OS), Windows_NT)
  LIBS=
else
  LIBS=-lpthread
endif

CC=gcc
CXX=g++

BIN=example5
OBJ=../../$(BIN).o

all: $(BIN)
	./$(BIN)

clean:
	- rm -f $(OBJ) $(BIN)

$(BIN): $(OBJ)
	$(CXX) $(OBJ) $(LFLAGS) $(LIBS) -o $(BIN)

=== debian/changelog ===
duma (2.5.15-2build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 22 Mar 2020 16:38:38 +0100

duma (2.5.15-2) unstable; urgency=medium

  * QA upload.
  * Set Maintainer to Debian QA Group.  (See: #565925)
  * Switch to source format 3.0 (quilt).  (Closes: #497947, #516370, #533554)
  * Switch from cdbs to dh.
  * Switch to debhelper-compat (= 12).  (Closes: #589715)
  * Fix some lintian issues.
  * dumapp.{cpp,h}: Apply patch from Buildroot (thanks, Yann E. MORIN!) to fix
    FTBFS with C++14.  (Closes: #811887)
  * Move git repository to salsa.d.o.

 -- Andreas Beckmann <anbe@debian.org>  Sun, 16 Jun 2019 11:47:57 +0200

duma (2.5.15-1) unstable; urgency=low

  * New upstream release (Closes: #531169)
  * Bump standard version

 -- Julien Danjou <acid@debian.org>  Thu, 04 Jun 2009 14:12:00 +0200

duma (2.5.14-2) unstable; urgency=low

  * Fix typo in long description (Closes: #486736)

 -- Julien Danjou <acid@debian.org>  Wed, 18 Jun 2008 00:09:42 +0200

duma (2.5.14-1) unstable; urgency=low

  * Initial release (Closes: #484473)

 -- Julien Danjou <acid@debian.org>  Thu, 12 Jun 2008 11:23:57 +0200

=== debian/control ===
Source: duma
Section: devel
Priority: optional
Maintainer: Debian QA Group <packages@qa.debian.org>
Build-Depends:
 debhelper-compat (= 12),
Standards-Version: 3.8.1
Homepage: http://duma.sf.net
Vcs-Browser: https://salsa.debian.org/debian/duma
Vcs-Git: https://salsa.debian.org/debian/duma.git

Package: duma
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: library to detect buffer overruns and under-runs in C and C++ programs
 Open-source library to detect buffer overruns and under-runs
 in C and C++ programs.
 .
 This library is a fork of Bruce Perens Electric Fence library and adds
 some new features to it. Features of the DUMA library:
   * "overloads" all standard memory allocation functions like
     malloc(), calloc(), memalign(), strdup(), operator new, operator
     new[] and also their counterpart deallocation functions like free(),
     operator delete and operator delete[]
   * utilizes the MMU (memory management unit) of the CPU:
     allocates and protects an extra memory page to detect any illegal
     access beyond the top of the buffer (or bottom, at the user's option)
   * stops the program at exactly that instruction, which does the
     erroneous access to the protected memory page,
     allowing location of the defective source code in a debugger
     detects erroneous writes at the non-protected end of the memory
     block at deallocation of the memory block
   * detects mismatch of allocation/deallocation functions: f.e.
     allocation with malloc() but deallocation with operator delete
   * leak detection: detect memory blocks which were not deallocated
     until program exit
   * preloading of the library
   * allowing tests without necessity of changing source code or recompilation

=== debian/watch ===
version=3

http://sf.net/duma/duma-(.*)\.tar\.gz

## duma 2.5.21

=== comparisons/ex11/Makefile ===

DUMADIR=../..
CFLAGS=-g -O0 -I$(DUMADIR) -include stdlib.h -include duma.h
LFLAGS=$(DUMADIR)/libduma.a
ifeq ($(OS), Windows_NT)
  LIBS=
else
  LIBS=-lpthread
endif

CC=gcc
CXX=g++

BIN=wrong1
OBJ=$(BIN).o

all: $(BIN)
	./$(BIN)

clean:
	- rm -f $(OBJ) $(BIN)

$(BIN): $(OBJ)
	$(CC) $(OBJ) $(LFLAGS) $(LIBS) -o $(BIN)

.c.o:
	$(CC) $(CFLAGS) -c $< -o $@

=== comparisons/ex12/Makefile ===

DUMADIR=../..
CFLAGS=-g -O0 -I$(DUMADIR) -include stdlib.h -include duma.h
LFLAGS=$(DUMADIR)/libduma.a
ifeq ($(OS), Windows_NT)
  LIBS=
else
  LIBS=-lpthread
endif

CC=gcc
CXX=g++

BIN=wrong3
OBJ=$(BIN).o

all: $(BIN)
	./$(BIN)

clean:
	- rm -f $(OBJ) $(BIN)

$(BIN): $(OBJ)
	$(CC) $(OBJ) $(LFLAGS) $(LIBS) -o $(BIN)

.c.o:
	$(CC) $(CFLAGS) -c $< -o $@

=== comparisons/ex16/Makefile ===

DUMADIR=../..
CFLAGS=-g -O0 -I$(DUMADIR) -include stdlib.h -include duma.h
LFLAGS=$(DUMADIR)/libduma.a
ifeq ($(OS), Windows_NT)
  LIBS=
else
  LIBS=-lpthread
endif

CC=gcc
CXX=g++

BIN=leak2
OBJ=$(BIN).o

all: $(BIN)
	./$(BIN)

clean:
	- rm -f $(OBJ) $(BIN)

$(BIN): $(OBJ)
	$(CC) $(OBJ) $(LFLAGS) $(LIBS) -o $(BIN)

.c.o:
	$(CC) $(CFLAGS) -c $< -o $@

=== comparisons/ex17/Makefile ===

DUMADIR=../..
CFLAGS=-g -O0 -I$(DUMADIR) -include stdlib.h -include duma.h
LFLAGS=$(DUMADIR)/libduma.a
ifeq ($(OS), Windows_NT)
  LIBS=
else
  LIBS=-lpthread
endif

CC=gcc
CXX=g++

BIN=ok5
OBJ=$(BIN).o

all: $(BIN)
	./$(BIN)

clean:
	- rm -f $(OBJ) $(BIN)

$(BIN): $(OBJ)
	$(CC) $(OBJ) $(LFLAGS) $(LIBS) -o $(BIN)

.c.o:
	$(CC) $(CFLAGS) -c $< -o $@

=== comparisons/ex23/Makefile ===

DUMADIR=../..
CPPFLAGS=-g -O0 -I$(DUMADIR) -include stdlib.h -include new -include dumapp.h
LFLAGS=$(DUMADIR)/libduma.a
ifeq ($(OS), Windows_NT)
  LIBS=
else
  LIBS=-lpthread
endif

CC=gcc
CXX=g++

BIN=wrong3
OBJ=$(BIN).o

all: $(BIN)
	./$(BIN)

clean:
	- rm -f $(OBJ) $(BIN)

$(BIN): $(OBJ)
	$(CXX) $(OBJ) $(LFLAGS) $(LIBS) -o $(BIN)

.cc.o:
	$(CXX) $(CPPFLAGS) -c $< -o $@

=== comparisons/ex25/Makefile ===

DUMADIR=../..
CPPFLAGS=-g -O0 -I$(DUMADIR) -include stdlib.h -include new -include dumapp.h
LFLAGS=$(DUMADIR)/libduma.a
ifeq ($(OS), Windows_NT)
  LIBS=
else
  LIBS=-lpthread
endif

CC=gcc
CXX=g++

BIN=wrong5
OBJ=$(BIN).o

all: $(BIN)
	./$(BIN)

clean:
	- rm -f $(OBJ) $(BIN)

$(BIN): $(OBJ)
	$(CXX) $(OBJ) $(LFLAGS) $(LIBS) -o $(BIN)

.cc.o:
	$(CXX) $(CPPFLAGS) -c $< -o $@

=== comparisons/ex26/Makefile ===

DUMADIR=../..
CPPFLAGS=-g -O0 -I$(DUMADIR) -include stdlib.h -include new -include dumapp.h
LFLAGS=$(DUMADIR)/libduma.a
ifeq ($(OS), Windows_NT)
  LIBS=
else
  LIBS=-lpthread
endif

CC=gcc
CXX=g++

BIN=wrong6
OBJ=$(BIN).o

all: $(BIN)
	./$(BIN)

clean:
	- rm -f $(OBJ) $(BIN)

$(BIN): $(OBJ)
	$(CXX) $(OBJ) $(LFLAGS) $(LIBS) -o $(BIN)

.cc.o:
	$(CXX) $(CPPFLAGS) -c $< -o $@

=== comparisons/ex28/Makefile ===

DUMADIR=../..
CPPFLAGS=-g -O0 -I$(DUMADIR) -include stdlib.h -include new -include dumapp.h
LFLAGS=$(DUMADIR)/libduma.a
ifeq ($(OS), Windows_NT)
  LIBS=
else
  LIBS=-lpthread
endif

CC=gcc
CXX=g++

BIN=leak2
OBJ=$(BIN).o

all: $(BIN)
	./$(BIN)

clean:
	- rm -f $(OBJ) $(BIN)

$(BIN): $(OBJ)
	$(CXX) $(OBJ) $(LFLAGS) $(LIBS) -o $(BIN)

.cc.o:
	$(CXX) $(CPPFLAGS) -c $< -o $@

=== comparisons/ex29/Makefile ===

DUMADIR=../..
CPPFLAGS=-g -O0 -I$(DUMADIR) -include stdlib.h -include new -include dumapp.h
LFLAGS=$(DUMADIR)/libduma.a
ifeq ($(OS), Windows_NT)
  LIBS=
else
  LIBS=-lpthread
endif

CC=gcc
CXX=g++

BIN=ok5
OBJ=$(BIN).o

all: $(BIN)
	./$(BIN)

clean:
	- rm -f $(OBJ) $(BIN)

$(BIN): $(OBJ)
	$(CXX) $(OBJ) $(LFLAGS) $(LIBS) -o $(BIN)

.cc.o:
	$(CXX) $(CPPFLAGS) -c $< -o $@

=== example_makes/ex2/Makefile ===

DUMADIR=../..
CPPFLAGS=-g -O0 -I$(DUMADIR)
LFLAGS=$(DUMADIR)/libduma.a
ifeq ($(OS), Windows_NT)
  LIBS=
else
  LIBS=-lpthread
endif

CC=gcc
CXX=g++

BIN=example2
OBJ=../../$(BIN).o

all: $(BIN)
	./$(BIN)

clean:
	- rm -f $(OBJ) $(BIN)

$(BIN): $(OBJ)
	$(CXX) $(OBJ) $(LFLAGS) $(LIBS) -o $(BIN)

=== example_makes/ex3/Makefile ===

DUMADIR=../..
CPPFLAGS=-g -O0 -I$(DUMADIR)
LFLAGS=$(DUMADIR)/libduma.a
ifeq ($(OS), Windows_NT)
  LIBS=
else
  LIBS=-lpthread
endif

CC=gcc
CXX=g++

BIN=example3
OBJ=../../$(BIN).o

all: $(BIN)
	./$(BIN)

clean:
	- rm -f $(OBJ) $(BIN)

$(BIN): $(OBJ)
	$(CXX) $(OBJ) $(LFLAGS) $(LIBS) -o $(BIN)

=== example_makes/ex6/Makefile ===

DUMADIR=../..
CPPFLAGS=-g -O0 -I$(DUMADIR) -include stdlib.h -include new -include dumapp.h
LFLAGS=$(DUMADIR)/libduma.a
ifeq ($(OS), Windows_NT)
  LIBS=
else
  LIBS=-lpthread
endif

CC=gcc
CXX=g++

BIN=example6
OBJ=../../$(BIN).o

all: $(BIN)
	./$(BIN)

clean:
	- rm -f $(OBJ) $(BIN)

$(BIN): $(OBJ)
	$(CXX) $(OBJ) $(LFLAGS) $(LIBS) -o $(BIN)

.cpp.o:
	$(CXX) $(CPPFLAGS) -c $< -o $@

=== debian/changelog ===
duma (2.5.21-8) unstable; urgency=medium

  * Copyright fixes
  * Add licenserecon to salsa CI

 -- Peter Blackman <peter@pblackman.plus.com>  Wed, 03 Jan 2024 17:00:00 +0000

duma (2.5.21-7) unstable; urgency=medium

  * Forward patches & update headers
  * Standards version 4.6.2 (no change)
  * Update copyright

 -- Peter Blackman <peter@pblackman.plus.com>  Fri, 01 Dec 2023 11:00:00 +0000

duma (2.5.21-6) unstable; urgency=medium

  * Lintian overrides
  * Bump standards version (no change)

 -- Peter Blackman <peter@pblackman.plus.com>  Sun, 07 Aug 2022 14:00:00 +0100

duma (2.5.21-5) unstable; urgency=medium

  * Fix build unreproducible in armhf

 -- Peter Blackman <peter@pblackman.plus.com>  Fri, 05 Nov 2021 20:00:00 +0000

duma (2.5.21-4) unstable; urgency=medium

  * Fix watch file
  * Fix blhc warnings on kfreebsd
  * Set DDUMA_NO_STRERROR (needed for #623495)

 -- Peter Blackman <peter@pblackman.plus.com>  Mon, 18 Oct 2021 10:00:00 +0100

duma (2.5.21-3) unstable; urgency=medium

  * Add gbp.conf  {pristine-tar = True}
  * Check signing key in watch file
  * Fix blhc warnings re compiler flags

 -- Peter Blackman <peter@pblackman.plus.com>  Thu, 14 Oct 2021 16:00:00 +0100

duma (2.5.21-2) unstable; urgency=medium

  * Fix depends in autopkgtest

 -- Peter Blackman <peter@pblackman.plus.com>  Sat, 02 Oct 2021 14:00:00 +0100

duma (2.5.21-1) unstable; urgency=medium

  * Adopt package. (Closes: #565925)
  * New Upstream Release. (Closes: #550660, #623495, #655892)
  * Fixes FTBFS with GCC-11  (#984041)
  * Use hardening flags, fixes bindnow, (Closes: #532483)
  * Use changelog file date instead of system date for build date
  * DEP-5 copyright
  * Add autopkgtests
  * Preserve Debian's CFLAGS etc (use += , not just = , in makefile)
  * Override Lintian's library warnings
     The library is not intended to be used directly by other programs

 -- Peter Blackman <peter@pblackman.plus.com>  Fri, 01 Oct 2021 14:00:00 +0100

duma (2.5.15-3) unstable; urgency=medium

  * QA upload.

  [ Debian Janitor ]
  * Use secure URI in debian/watch.
  * Set upstream metadata fields: Archive.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Sun, 22 Aug 2021 03:45:54 +0100

=== debian/control ===
--- 
+++ 
@@ -1,18 +1,18 @@
 Source: duma
 Section: devel
 Priority: optional
-Maintainer: Debian QA Group <packages@qa.debian.org>
-Build-Depends:
- debhelper-compat (= 12),
-Standards-Version: 3.8.1
-Homepage: http://duma.sf.net
+Maintainer: Peter Blackman <peter@pblackman.plus.com>
+Build-Depends: debhelper-compat (= 13)
+Rules-Requires-Root: no
+Standards-Version: 4.6.2
+Homepage: https://github.com/johnsonjh/duma
 Vcs-Browser: https://salsa.debian.org/debian/duma
 Vcs-Git: https://salsa.debian.org/debian/duma.git
 
 Package: duma
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
-Description: library to detect buffer overruns and under-runs in C and C++ programs
+Description: Detect Unintended Memory Access - A Red-Zone memory allocator
  Open-source library to detect buffer overruns and under-runs
  in C and C++ programs.
  .

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_HOST_ARCH

%:
# Build may break without --no-parallel
	dh $@ --no-parallel

# Wrong variable used for C++
override_dh_auto_build:
	  sed -i "s|CPPFLAGS|CXXFLAGS|"   GNUmakefile
	  dh_auto_build

override_dh_auto_clean:
	  sed -i "s|CXXFLAGS|CPPFLAGS|"   GNUmakefile
	  dh_auto_clean

=== debian/tests/control ===
# Autopkgtests for duma
#
# Tests need object files form the build tree
# Use installed makefile, as patches may be needed

Test-Command: gmake -f /usr/share/duma/GNUmakefile check
Features: test-name=makefile-check
Depends: @, build-essential
Restrictions: build-needed, allow-stderr

Test-Command: gmake -f /usr/share/duma/GNUmakefile installcheck
Features: test-name=makefile-installcheck
Depends: @, make
Restrictions: build-needed, allow-stderr
